import { Event } from 'vscode-jsonrpc';
import { WorkspaceFolder, WorkspaceFoldersChangeEvent, ConfigurationItem } from 'vscode-languageserver-protocol';
import { _, Features, WorkspaceFeature } from './main';
export interface WorkspaceFoldersProposed {
    getWorkspaceFolders(): Thenable<WorkspaceFolder[] | null>;
    onDidChangeWorkspaceFolders: Event<WorkspaceFoldersChangeEvent>;
}
export declare const WorkspaceFoldersFeature: WorkspaceFeature<WorkspaceFoldersProposed>;
export interface ConfigurationProposed {
    getConfiguration(): Thenable<any>;
    getConfiguration(section: string): Thenable<any>;
    getConfiguration(item: ConfigurationItem): Thenable<any>;
    getConfiguration(items: ConfigurationItem[]): Thenable<any[]>;
}
export declare const GetConfigurationFeature: WorkspaceFeature<ConfigurationProposed>;
export declare const ProposedProtocol: Features<_, _, _, _, _, WorkspaceFoldersProposed & ConfigurationProposed>;
